<?php

/**
*  Класс для работы с алгоритмом сжатия LZMA
* 
* Зависит от Temp, FileBuffer и lzma.exe
* 
*/
class Oodle {

    private static $_error;

    public static function decode( $data ){  
        
        $uncompressedFile = Temp::getFileName();  
        $compressedFile = $uncompressedFile . ".oodle";  

        if( @file_put_contents( $compressedFile, $data ) === false ){

            return self::_error( "Не удалось записать временный файл" );

        };

        $exe = __DIR__ . "\\bin\\oodle.exe";
        $cmd = "\"{$exe}\" \"$compressedFile\" \"$uncompressedFile\"";

        if( exec( $cmd, $output, $code ) === false ){

            return self::_error( "Не удалось запустить декомпрессор" );    

        };
        
        unlink( $compressedFile );

        if( $code ){

            return self::_error( "Ошибка декомпрессии" );

        }

        $data = @file_get_contents( $uncompressedFile );
        unlink( $uncompressedFile );

        if( $data === false ) {

            return self::_error( "Не удалось прочитать временный файл" );

        }

        return $data;

    }

    private static function _error( $error ){

        self::$_error = $error;

        return false;

    }

    public static function getLastError(){

        return self::$_error;

    }
}

?>