<?php

class FileName{
	
	/**
	 * Нормализует имя файла
	 * 
	 * @param string $path
	 * 
	 * @return string
	 */
	public static function normalizeFileName( $filename ) {

		$filename = str_replace( "\\", "/", $filename );
		$filename = str_replace( "//", "/", $filename );
		$filename = strtolower( $filename );  

		return $filename;

	}

	/**
	 * Нормализует имя папки. 
	 * Заменяет слеши и добавляет в конец закрывающий слеш.
	 *
	 * @param string $path
	 * 
	 * @return string
	 */
	public static function normalizeDirName( $path ) {

		return self::normalizeFileName( $path . "/" );

	} 
	
	/**
	* Возвращает нормализованный полный путь к файлу
	* 
	* @param mixed $filePath
	*/
	public static function getRealFilePath( $filePath ){
		
		return self::normalizeFileName( realpath( $filePath ) );
		
	}
	
	/**
	* Возвращает нормализованный полный путь к папке
	* 
	* @param mixed $dirPath
	*/
	public static function getRealDirPath( $dirPath ){
		
		return self::normalizeDirName( realpath( $dirPath ) );
		
	}

	/**
	* Получает расширение файла.
	* Возвращаемое расширение не имеет точки.
	* 
	* @param mixed $filename
	* 
	* @return string
	*/
	public static function getFileExt( string $filename ) {

		return  pathinfo($filename, PATHINFO_EXTENSION);

	}

}

?>