<?php

class Temp {

	private static $_error;
	private static $_tempDir = false;

	/**
	* Возвращает путь к временной папке
	* 
	* @return string Имя папки или false при неудаче
	*/
	public static function getDir(){    

		if( !self::$_tempDir ){

			if( is_readable( "R:/" ) ){

				self::$_tempDir = "R:/temp/";

			}
			else {

				self::$_tempDir = "temp/";

			}

			if( !createDir( self::$_tempDir ) ){

				return $this->_error( "Не удалось создать временную папку" );

			}
		}

		return FileName::normalizeDirName( self::$_tempDir );

	}

	/**
	* Возвращает имя временного файла
	* 
	* @param string $ext Желаниемое расширение файла
	* 
	* @return string Имя файла или false при неудаче
	*/
	public static function getFileName( $ext = "" ){ 

		$tempDir = self::getDir();

		if( !$tempDir ) {

			return $this->_error( "Не удалось создать временную папку" );

		} 

		$fileName = substr( md5( microtime() ), rand( 0, 18 ), 14 );

		if( $ext ){

			$fileName = $fileName . ".{$ext}"; 

		}

		return FileName::normalizeFileName( $tempDir . $fileName );

	}

	/**
	* Полная очистка временной папки
	* 
	*/
	public static function clear(){

		if( self::$_tempDir ) {

			clearDir( self::$_tempDir );

		}

		return true;

	}

	private static function _error( $error ){

		$this->_error = $error;

		return false;

	}

	public static function getError(){

		return $this->_error;

	}
}

?>